#include<bits/stdc++.h>
using namespace std;

int res;

void Resi(int N, int R, int C, int Q, int** U, int** V, int** W,
	int* X1, int* Y1, int* X2, int* Y2, int* O)
{
    if(N!=2)
	for (int i=1; i<=Q; i++)
		O[i] = -1;
    else
    {
        for(int i=1;i<=Q;i++)
        {
            res=1000000000;
            for(int j=X1[i];j<=X2[i];j++)
            {
                for(int k=Y1[i];k<=Y2[i];k++)
                    res=min(res,W[j][k]);
            }
            O[i]=res;
        }
    }
}